




#include  <msp430x42x0.h>


#define a 0x80
#define b 0x40
#define c 0x20
#define h 0x10
#define f 0x08
#define g 0x04
#define e 0x02
#define d 0x01

const char distab[] = {                   // definitions for digits
  a+b+c+d+e+f,                              // Displays "0"
  b+c,                                      // Displays "1"
  a+b+d+e+g,                                // Displays "2"
  a+b+c+d+g,                                // Displays "3"
  b+c+f+g,                                  // Displays "4"
  a+c+d+f+g,                                // Displays "5"
  a+c+d+e+f+g,                              // Displays "6"
  a+b+c,                                    // Displays "7"
  a+b+c+d+e+f+g,                            // Displays "8"
  a+b+c+d+f+g   ,                            // Displays "9"
    
  a+b+c+d+e+f+h,                              // Displays "0"
  b+c+h,                                      // Displays "1"
  h+a+b+d+e+g,                                // Displays "2"
  h+a+b+c+d+g,                                // Displays "3"
  h+b+c+f+g,                                  // Displays "4"
  h+a+c+d+f+g,                                // Displays "5"
  h+a+c+d+e+f+g,                              // Displays "6"
  h+a+b+c,                                    // Displays "7"
  h+a+b+c+d+e+f+g,                            // Displays "8"
  h+a+b+c+d+f+g                               // Displays "9"
};

//const int dot[128]={0x800,0x864,0x8c8,0x92c,0x98f,0x9f1,0xa52,0xab1,0xb0f,0xb6b,0xbc4,0xc1c,0xc71,0xcc3,0xd12,0xd5e,0xda7,0xdec,0xe2e,0xe6c,0xea6,0xedc,0xf0d,0xf3a,0xf63,0xf87,0xfa7,0xfc2,0xfd8,0xfe9,0xff5,0xffd,0xfff,0xffd,0xff6,0xfea,0xfd9,0xfc3,0xfa8,0xf88,0xf64,0xf3c,0xf0f,0xedd,0xea8,0xe6e,0xe30,0xdef,0xda9,0xd61,0xd15,0xcc6,0xc74,0xc1f,0xbc7,0xb6e,0xb12,0xab4,0xa55,0x9f4,0x992,0x92f,0x8cb,0x867,0x803,0x79e,0x73a,0x6d6,0x673,0x611,0x5b0,0x551,0x4f3,0x497,0x43d,0x3e6,0x391,0x33f,0x2ef,0x2a3,0x25a,0x215,0x1d3,0x195,0x15b,0x125,0xf3,0xc6,0x9d,0x79,0x59,0x3e,0x28,0x16,0xa,0x2,0x0,0x2,0x9,0x15,0x26,0x3c,0x56,0x75,0x99,0xc2,0xef,0x120,0x156,0x18f,0x1cd,0x20e,0x253,0x29c,0x2e8,0x337,0x389,0x3de,0x435,0x48e,0x4ea,0x548,0x5a7,0x608,0x66a,0x6cd,0x730,0x795};
const int dot[16]={0x800,0xb0f,0xda7,0xf63,0xfff,0xf64,0xda9,0xb12,0x803,0x4f3,0x25a,0x9d,0x0,0x99,0x253,0x4ea};
int xxxx = 0 ;

void delay(int x)   // 5*x+12  nop
      {             //128- 23    256-49
          while(x--);   
      }             //192- 36    280- 54   448- 87
      


void main(void)
{
  WDTCTL = WDTPW + WDTHOLD;                 // Stop WDT
  FLL_CTL0 |= XCAP14PF;                     // Configure load caps
  P1DIR |= 0x01;                            // Set P1.0 to output direction
  CCTL0 = CCIE;                             // CCR0 interrupt enabled
  CCR0 = 80;
  TACTL = TASSEL_2 + MC_1;                  // ACLK, up mode
  
  FLL_CTL0 |= XCAP14PF;                     // Set load cap for 32k xtal
  LCDACTL = LCDON + LCD4MUX + LCDFREQ_128;  // 4mux LCD, ACLK/128
  LCDAPCTL0 = 0x07;                         // Segments 0-13

  P5SEL  = 0x1C;                            // Set COM pins for LCD

  DAC12_0CTL = DAC12OPS + DAC12SREF_1 + DAC12IR + DAC12AMP_5 + DAC12ENC;
                                            // DAC o/p external, Ref Voltage = AVcc,
                                            // O/p Voltage range = 1x ref, Enable conversion 1
  DAC12_0DAT = 0x555;                       // 1V

  _BIS_SR(LPM0_bits + GIE);                 // Enter LPM3 w/ interrupt
}


// Timer A0 interrupt service routine
#pragma vector=TIMERA0_VECTOR
__interrupt void Timer_A (void)
{
  DAC12_0DAT = dot[xxxx];    
  xxxx ++ ;
  if(xxxx >= 16)
    xxxx = 0 ;
}
