




#include  <msp430x42x0.h>


#define a 0x80
#define b 0x40
#define c 0x20
#define h 0x10
#define f 0x08
#define g 0x04
#define e 0x02
#define d 0x01

const char distab[] = {                   // definitions for digits
  a+b+c+d+e+f,                              // Displays "0"
  b+c,                                      // Displays "1"
  a+b+d+e+g,                                // Displays "2"
  a+b+c+d+g,                                // Displays "3"
  b+c+f+g,                                  // Displays "4"
  a+c+d+f+g,                                // Displays "5"
  a+c+d+e+f+g,                              // Displays "6"
  a+b+c,                                    // Displays "7"
  a+b+c+d+e+f+g,                            // Displays "8"
  a+b+c+d+f+g   ,                            // Displays "9"
    
  a+b+c+d+e+f+h,                              // Displays "0"
  b+c+h,                                      // Displays "1"
  h+a+b+d+e+g,                                // Displays "2"
  h+a+b+c+d+g,                                // Displays "3"
  h+b+c+f+g,                                  // Displays "4"
  h+a+c+d+f+g,                                // Displays "5"
  h+a+c+d+e+f+g,                              // Displays "6"
  h+a+b+c,                                    // Displays "7"
  h+a+b+c+d+e+f+g,                            // Displays "8"
  h+a+b+c+d+f+g                               // Displays "9"
};


void delay(int x)   // 5*x+12  nop
      {             //128- 23    256-49
          while(x--);   
      }             //192- 36    280- 54   448- 87
      


void main(void)
{
  WDTCTL = WDTPW + WDTHOLD;                 // Stop WDT
  FLL_CTL0 |= XCAP14PF;                     // Configure load caps
  P1DIR |= 0x01;                            // Set P1.0 to output direction
  CCTL0 = CCIE;                             // CCR0 interrupt enabled
  CCR0 = 32768-1;
  TACTL = TASSEL_1 + MC_1;                  // ACLK, up mode
  FLL_CTL0 |= XCAP14PF;                     // Set load cap for 32k xtal
  LCDACTL = LCDON + LCD4MUX + LCDFREQ_128;  // 4mux LCD, ACLK/128
  LCDAPCTL0 = 0x07;                         // Segments 0-13

  P5SEL  = 0x1C;                            // Set COM pins for LCD

  _BIS_SR(LPM3_bits + GIE);                 // Enter LPM3 w/ interrupt
}

// Timer A0 interrupt service routine
#pragma vector=TIMERA0_VECTOR
__interrupt void Timer_A (void)
  {
    
    unsigned int results = 0 ;
     
    SD16CTL = SD16REFON + SD16SSEL0;            // 1.2V ref, SMCLK
    SD16CCTL0 |= SD16SNGL;                    // Single conv
    SD16INCTL0 =  SD16INCH_6; 
    delay(600);
      SD16CCTL0 |= SD16SC;                    // Set bit to start conversion
      while ((SD16CCTL0 & SD16IFG)==0);       // Poll interrupt flag
      results = SD16MEM0;                     // Save CH0 results (clears IFG)
      _NOP();                                 // SET BREAKPOINT HERE
      
      char i;
      for(i=0;i<5;i++)
        {
          LCDMEM[5-i] = distab[results % 10 ];
         results = results  / 10 ;
        }
    }

//    DegC = ((unsigned long)ADCresult * 909)/65536 - 727;
                                            // Calculate degrees Celcius
  //  DegF = ((unsigned long)ADCresult * 1636)/65536 - 1276;
